package gonganxitong

import (
	"time"

	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/aaa"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type user struct {
	Table
	template string `data:"4b-Z_r8dZmm1pHdd2h4A10VVYX4OIHvemlLjsHKBj2s"`
	create   string `name:"create openid* headimgurl nickname"`
	email    string `name:"email email*"`
}

func (s user) Create(m *ice.Message, arg ...string) {
	if s.Table.Select(m, m.OptionSimple(model.OPEN_ID)...).Length() == 0 {
		s.Table.Create(m, kit.Simple(m.OptionSimple(model.OPEN_ID, model.AVATAR), model.NAME, m.Option(aaa.USERNICK))...)
		m.Option(model.USER_UID, m.Result())
	} else {
		m.Option(model.USER_UID, m.Append(model.UID))
	}
}
func (s user) Email(m *ice.Message, arg ...string) {
	s.Table.Update(m, m.OptionSimple(model.EMAIL), model.UID, m.Option(model.USER_UID))
}

func init() { ice.Cmd(prefixKey(), user{}) }

func (s user) SendTemplate(m *ice.Message, arg ...string) { // uid url type name hash
	msg := s.Select(m, model.UID, arg[0])
	m.Cmdy("web.chat.wx.template", "", m.Config("template"), msg.Append(model.OPEN_ID), kit.Select("", arg, 1),
		"thing7", kit.Select("", arg, 2), "thing12", kit.Select("", arg, 3), "character_string2", kit.Cut(kit.Select("", arg, 4), 6),
		"time11", time.Now().Format("2006年01月02日 15:04"), "thing18", msg.Append(model.NAME),
	)
}

type User struct{ user }

func init() { ice.Cmd(prefixKey(), User{}) }
