package gonganxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type event struct {
	Table
	user   user
	portal string `data:"true"`
}

func (s event) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.user).Fields(m,
		"events.created_at", "events.uid",
		"index", "operate", "args",
		"users.avatar AS icons", "user_name", "user_uid",
	).Orders(m, "created_at DESC").Select(m).Display("")
}
func init() { ice.Cmd(prefixKey(), event{}) }

func (s event) Record(m *ice.Message, arg ...string) {
	m.Cmd(s, s.Create, m.OptionSimple(model.USER_UID, model.PLACE_UID), ctx.INDEX, m.PrefixKey(), "operate", m.ActionKey(), ctx.ARGS, kit.Join(arg, ","))
}
